import 'package:flutter/material.dart';
import 'dart:async';
import 'package:interactive_game_sdk/interactive_game_sdk.dart';
import 'package:interactive_game_sdk/events.dart';
import 'package:interactive_game_sdk/interactive_game_player.dart';

class LiveRoom extends StatefulWidget {
  @override
  State<StatefulWidget> createState() {
    return _LiveRoom();
  }
}

class _LiveRoom extends State<LiveRoom> {
  @override
  void initState() {
    super.initState();
    initPlatformState();
  }

  SWGameClient gameClient;
  SWGamePlayer gamePlayer;
  SWGamePlayer gamePlayer2;
  SWGamePlayer gamePlayer3;

  Future<void> initPlatformState() async {
    gameClient = SWGameClient();
    gameClient.setEventHandler(GameClientChannelEventHandler(
      error: (error) {
        print('errorCode $error');
      },
      onJoinChannelFailed: (channel, errorCode, errorMsg) {
        print('channel $channel errorCode $errorCode  errorMsg $errorMsg');
      },
      onUserListUpdate: (userList) {},
      onPlayUpdate: (padCodeList) {
        gamePlayer.startPlay(padCodeList[0]);
        String padCode = padCodeList[0];
        print('padCodeList $padCode');
      },
    ));
    gameClient.init('634f0e0fba124c328b53740f67a2cada');
    // gamePlayer = SWGamePlayer.createPlayerView();
    // gamePlayer2 = SWGamePlayer.createPlayerView();
    // gamePlayer3 = SWGamePlayer.createPlayerView();
    if (!mounted) return;
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: const Text('Plugin iOS'),
      ),
      body: new Column(
        children: [
          new OutlineButton(
            child: Text('点击初始化GameClient'),
            onPressed: () {
              gameClient.init('appId');
            },
          ),
          new OutlineButton(
            child: Text('点击加入频道'),
            onPressed: () {
              gameClient.joinChannel('channelId', 'uid', "");
            },
          ),
          new OutlineButton(
            child: Text('点击设置云游戏setPlayCloudGame'),
            onPressed: () {
              gameClient.setPlayCloudGame(43);
            },
          ),
          new OutlineButton(
            child: Text('点击离开频道'),
            onPressed: () {
              gameClient.leaveChannel();
            },
          ),
          new Row(children: [
            new OutlineButton(
              child: Text('点击改变颜色'),
              onPressed: () {},
            ),
            new OutlineButton(
              child: Text('点击改变颜色'),
              onPressed: () {},
            ),
            new OutlineButton(
              child: Text('点击改变颜色'),
              onPressed: () {},
            ),
          ]),
          new Row(children: [
            Container(
              width: 100.0,
              height: 100.0,
              child: gamePlayer?.playerView,
            ),
            Container(
              width: 100.0,
              height: 100.0,
              child: gamePlayer2?.playerView,
            ),
            Container(
              width: 100.0,
              height: 100.0,
              child: gamePlayer3?.playerView,
            ),
          ]),
        ],
      ),
    );
  }
}
