//
//  FlutterPlayerView.h
//  interactive_game_sdk
//
//  Created by edz on 2020/9/15.
//

#import <Foundation/Foundation.h>
#import <Flutter/Flutter.h>
#import "SWGameClient.h"

NS_ASSUME_NONNULL_BEGIN

@interface FlutterPlayerViewFactory : NSObject <FlutterPlatformViewFactory>

- (instancetype)initWithMessenger:(NSObject<FlutterBinaryMessenger> *)messenger;

- (void)setGameClient:(SWGameClient *)gameClient;

- (void)destroy;

@end

@interface FlutterPlayerView : NSObject<FlutterPlatformView>

- (instancetype)initWithFrame:(CGRect)frame
               viewIdentifier:(int64_t)viewId
                    arguments:(id _Nullable)args
              binaryMessenger:(NSObject<FlutterBinaryMessenger> *)messenger
                   gameClient:(SWGameClient *)gameClient;

- (UIView *)view;

- (void)destroy;

@end

NS_ASSUME_NONNULL_END
